"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var preferences_common_1 = require("./preferences.common");
var Preferences = (function (_super) {
    __extends(Preferences, _super);
    function Preferences() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Preferences.prototype.setValue = function (key, value) {
        NSUserDefaults.standardUserDefaults.setValueForKey(value, key);
    };
    Preferences.prototype.getValue = function (key) {
        var standardUserDefaults = NSUserDefaults.standardUserDefaults;
        var us = standardUserDefaults.objectForKey(key);
        if (us == null) {
            this.registerDefaultsFromSettingsBundle();
        }
        return NSUserDefaults.standardUserDefaults.objectForKey(key);
    };
    Preferences.prototype.openSettings = function () {
        UIApplication.sharedApplication.openURL(NSURL.URLWithString(UIApplicationOpenSettingsURLString));
    };
    Preferences.prototype.clear = function () {
    };
    Preferences.prototype.registerDefaultsFromSettingsBundle = function () {
        var settingsPath = NSBundle.mainBundle.pathForResourceOfType("Settings", "bundle");
        var settingsBundle = NSString.stringWithString(settingsPath);
        var rootPath = settingsBundle.stringByAppendingPathComponent("Root.plist");
        var settings = NSDictionary.dictionaryWithContentsOfFile(rootPath);
        var preferences = settings.objectForKey("PreferenceSpecifiers");
        var prefs = preferences.count;
        var defaultsToRegister = NSMutableDictionary.alloc().initWithCapacity(prefs);
        for (var i = 0; i < prefs; i++) {
            var prefSpecification = preferences.objectAtIndex(i);
            var key = prefSpecification.objectForKey("Key");
            if (key) {
                defaultsToRegister.setObjectForKey("", key);
            }
        }
        NSUserDefaults.standardUserDefaults.registerDefaults(defaultsToRegister);
        NSUserDefaults.standardUserDefaults.synchronize();
    };
    return Preferences;
}(preferences_common_1.Common));
exports.Preferences = Preferences;
//# sourceMappingURL=preferences.ios.js.map